Index: palm/trunk/SOURCE/advec_ws.f90
===================================================================
--- palm/trunk/SOURCE/advec_ws.f90	(revision 4465)
+++ palm/trunk/SOURCE/advec_ws.f90	(revision 4466)
@@ -5329,102 +5349,76 @@
                                                            )
 
-          ENDDO
-
-          DO  k = nzb_max_l+1, nzt
-
-             u_comp                   = u(k,j-1,i) + u(k,j,i) - gu
-             swap_flux_x_local_v(k,j) = u_comp * (                             &
+                ENDDO
+
+                DO  k = nzb_max_l+1, nzt
+
+                   u_comp(k)        = u(k,j-1,i) + u(k,j,i) - gu
+                   flux_l_v(k,j,tn) = u_comp(k) * (                            &
                              37.0_wp * ( v(k,j,i) + v(k,j,i-1)   )             &
                            -  8.0_wp * ( v(k,j,i+1) + v(k,j,i-2) )             &
                            +           ( v(k,j,i+2) + v(k,j,i-3) ) ) * adv_mom_5
-             swap_diss_x_local_v(k,j) = - ABS( u_comp ) * (                    &
+                   diss_l_v(k,j,tn) = - ABS( u_comp(k) ) * (                   &
                              10.0_wp * ( v(k,j,i) - v(k,j,i-1)   )             &
                            -  5.0_wp * ( v(k,j,i+1) - v(k,j,i-2) )             &
                            +           ( v(k,j,i+2) - v(k,j,i-3) ) ) * adv_mom_5
 
-          ENDDO
-
-       ENDDO
+                ENDDO
+             ENDIF
+
+             IF ( j == nysv )  THEN
+                DO  k = nzb+1, nzb_max_l
+
+                   ibit14 = REAL( IBITS(advc_flags_m(k,j-1,i),14,1), KIND = wp )
+                   ibit13 = REAL( IBITS(advc_flags_m(k,j-1,i),13,1), KIND = wp )
+                   ibit12 = REAL( IBITS(advc_flags_m(k,j-1,i),12,1), KIND = wp )
+
+                   v_comp(k)      = v(k,j,i) + v(k,j-1,i) - gv
+                   flux_s_v(k,tn) = v_comp(k) * (                              &
+                                         ( 37.0_wp * ibit14 * adv_mom_5        &
+                                      +     7.0_wp * ibit13 * adv_mom_3        &
+                                      +              ibit12 * adv_mom_1        &
+                                         ) *                                   &
+                                           ( v(k,j,i)   + v(k,j-1,i) )         &
+                                  -      (  8.0_wp * ibit14 * adv_mom_5        &
+                                      +              ibit13 * adv_mom_3        &
+                                         ) *                                   &
+                                           ( v(k,j+1,i) + v(k,j-2,i) )         &
+                                  +      (           ibit14 * adv_mom_5        &
+                                         ) *                                   &
+                                           ( v(k,j+2,i) + v(k,j-3,i) )         &
+                                                )
+
+                   diss_s_v(k,tn) = - ABS( v_comp(k) ) * (                     &
+                                         ( 10.0_wp * ibit14 * adv_mom_5        &
+                                      +     3.0_wp * ibit13 * adv_mom_3        &
+                                      +              ibit12 * adv_mom_1        &
+                                         ) *                                   &
+                                           ( v(k,j,i)   - v(k,j-1,i) )         &
+                                  -      (  5.0_wp * ibit14 * adv_mom_5        &
+                                      +              ibit13 * adv_mom_3        &
+                                         ) *                                   &
+                                           ( v(k,j+1,i) - v(k,j-2,i) )         &
+                                  +      (           ibit14 * adv_mom_5        &
+                                         ) *                                   &
+                                           ( v(k,j+2,i) - v(k,j-3,i) )         &
+                                                         )
+
+                ENDDO
+
+                DO  k = nzb_max_l+1, nzt
+
+                   v_comp(k)      = v(k,j,i) + v(k,j-1,i) - gv
+                   flux_s_v(k,tn) = v_comp(k) * (                              &
+                                 37.0_wp * ( v(k,j,i) + v(k,j-1,i)   )         &
+                               -  8.0_wp * ( v(k,j+1,i) + v(k,j-2,i) )         &
+                               +           ( v(k,j+2,i) + v(k,j-3,i) ) ) * adv_mom_5
+                   diss_s_v(k,tn) = - ABS( v_comp(k) ) * (                     &
+                                 10.0_wp * ( v(k,j,i) - v(k,j-1,i)   )         &
+                               -  5.0_wp * ( v(k,j+1,i) - v(k,j-2,i) )         &
+                               +           ( v(k,j+2,i) - v(k,j-3,i) ) ) * adv_mom_5
+
+                ENDDO
+             ENDIF
 #endif
-
-       !$ACC PARALLEL LOOP COLLAPSE(2) FIRSTPRIVATE(tn, gu, gv) &
-       !$ACC PRIVATE(i, j, k, k_mm, k_pp, k_ppp) &
-       !$ACC PRIVATE(ibit9, ibit10, ibit11, ibit12, ibit13, ibit14) &
-       !$ACC PRIVATE(ibit9_l, ibit10_l, ibit11_l) &
-       !$ACC PRIVATE(ibit12_s, ibit13_s, ibit14_s) &
-       !$ACC PRIVATE(ibit15, ibit16, ibit17) &
-       !$ACC PRIVATE(flux_r, diss_r, flux_l, diss_l) &
-       !$ACC PRIVATE(flux_n, diss_n, flux_s, diss_s) &
-       !$ACC PRIVATE(flux_t, diss_t, flux_d, diss_d) &
-       !$ACC PRIVATE(div, u_comp, u_comp_l, v_comp, v_comp_s, w_comp) &
-       !$ACC PRESENT(advc_flags_m) &
-       !$ACC PRESENT(u, v, w) &
-       !$ACC PRESENT(drho_air, rho_air_zw, ddzw) &
-       !$ACC PRESENT(tend) &
-       !$ACC PRESENT(hom(nzb+1:nzb_max_l,1,2:3,0)) &
-       !$ACC PRESENT(weight_substep(intermediate_timestep_count)) &
-       !$ACC PRESENT(sums_vs2_ws_l, sums_wsvs_ws_l)
-       DO i = nxl, nxr
-
-#ifndef _OPENACC
-          j = nysv
-          DO  k = nzb+1, nzb_max_l
-
-             ibit14 = REAL( IBITS(advc_flags_m(k,j-1,i),14,1), KIND = wp )
-             ibit13 = REAL( IBITS(advc_flags_m(k,j-1,i),13,1), KIND = wp )
-             ibit12 = REAL( IBITS(advc_flags_m(k,j-1,i),12,1), KIND = wp )
-
-             v_comp                 = v(k,j,i) + v(k,j-1,i) - gv
-             swap_flux_y_local_v(k) = v_comp * (                               &
-                                   ( 37.0_wp * ibit14 * adv_mom_5              &
-                                +     7.0_wp * ibit13 * adv_mom_3              &
-                                +              ibit12 * adv_mom_1              &
-                                   ) *                                         &
-                                     ( v(k,j,i)   + v(k,j-1,i) )               &
-                            -      (  8.0_wp * ibit14 * adv_mom_5              &
-                                +              ibit13 * adv_mom_3              &
-                                   ) *                                         &
-                                     ( v(k,j+1,i) + v(k,j-2,i) )               &
-                            +      (           ibit14 * adv_mom_5              &
-                                   ) *                                         &
-                                     ( v(k,j+2,i) + v(k,j-3,i) )               &
-                                                 )
-
-             swap_diss_y_local_v(k) = - ABS( v_comp ) * (                      &
-                                   ( 10.0_wp * ibit14 * adv_mom_5              &
-                                +     3.0_wp * ibit13 * adv_mom_3              &
-                                +              ibit12 * adv_mom_1              &
-                                   ) *                                         &
-                                     ( v(k,j,i)   - v(k,j-1,i) )               &
-                            -      (  5.0_wp * ibit14 * adv_mom_5              &
-                                +              ibit13 * adv_mom_3              &
-                                   ) *                                         &
-                                     ( v(k,j+1,i) - v(k,j-2,i) )               &
-                            +      (           ibit14 * adv_mom_5              &
-                                   ) *                                         &
-                                     ( v(k,j+2,i) - v(k,j-3,i) )               &
-                                                          )
-
-          ENDDO
-
-          DO  k = nzb_max_l+1, nzt
-
-             v_comp                 = v(k,j,i) + v(k,j-1,i) - gv
-             swap_flux_y_local_v(k) = v_comp * (                               &
-                           37.0_wp * ( v(k,j,i) + v(k,j-1,i)   )               &
-                         -  8.0_wp * ( v(k,j+1,i) + v(k,j-2,i) )               &
-                         +           ( v(k,j+2,i) + v(k,j-3,i) ) ) * adv_mom_5
-             swap_diss_y_local_v(k) = - ABS( v_comp ) * (                      &
-                           10.0_wp * ( v(k,j,i) - v(k,j-1,i)   )               &
-                         -  5.0_wp * ( v(k,j+1,i) - v(k,j-2,i) )               &
-                         +           ( v(k,j+2,i) - v(k,j-3,i) ) ) * adv_mom_5
-
-          ENDDO
-#endif
-
-          DO  j = nysv, nyn
-
-             flux_d    = 0.0_wp
-             diss_d    = 0.0_wp
 
              DO  k = nzb+1, nzb_max_l
@@ -5434,6 +5428,6 @@
                 ibit9  = REAL( IBITS(advc_flags_m(k,j,i),9,1),  KIND = wp )
 
-                u_comp = u(k,j-1,i+1) + u(k,j,i+1) - gu
-                flux_r = u_comp * (                                            &
+                u_comp(k) = u(k,j-1,i+1) + u(k,j,i+1) - gu
+                flux_r(k) = u_comp(k) * (                                      &
                           ( 37.0_wp * ibit11 * adv_mom_5                       &
                        +     7.0_wp * ibit10 * adv_mom_3                       &
@@ -5448,7 +5442,7 @@
                           ) *                                                  &
                                  ( v(k,j,i+3) + v(k,j,i-2) )                   &
-                                     )
-
-                diss_r = - ABS( u_comp ) * (                                   &
+                                        )
+
+                diss_r(k) = - ABS( u_comp(k) ) * (                             &
                           ( 10.0_wp * ibit11 * adv_mom_5                       &
                        +     3.0_wp * ibit10 * adv_mom_3                       &
@@ -5463,5 +5457,5 @@
                           ) *                                                  &
                                  ( v(k,j,i+3) - v(k,j,i-2) )                   &
-                                              )
+                                                 )
 
 #ifdef _OPENACC
@@ -5472,6 +5466,6 @@
                 ibit9_l  = REAL( IBITS(advc_flags_m(k,j,i-1),9,1),  KIND = wp )
 
-                u_comp_l  = u(k,j-1,i) + u(k,j,i) - gu
-                flux_l    = u_comp_l * (                                       &
+                u_comp_l            = u(k,j-1,i) + u(k,j,i) - gu
+                flux_l_v(k,j,tn)    = u_comp_l * (                             &
                                       ( 37.0_wp * ibit11_l * adv_mom_5         &
                                    +     7.0_wp * ibit10_l * adv_mom_3         &
@@ -5488,5 +5482,5 @@
                                                  )
 
-                 diss_l   = - ABS( u_comp_l ) * (                              &
+                 diss_l_v(k,j,tn)   = - ABS( u_comp_l ) * (                    &
                                       ( 10.0_wp * ibit11_l * adv_mom_5         &
                                    +     3.0_wp * ibit10_l * adv_mom_3         &
@@ -5502,7 +5496,4 @@
                                      ( v(k,j,i+2) - v(k,j,i-3) )               &
                                                            )
-#else
-                flux_l = swap_flux_x_local_v(k,j)
-                diss_l = swap_diss_x_local_v(k,j)
 #endif
 
@@ -5511,6 +5502,6 @@
                 ibit12 = REAL( IBITS(advc_flags_m(k,j,i),12,1), KIND = wp )
 
-                v_comp = v(k,j+1,i) + v(k,j,i)
-                flux_n = ( v_comp - gv ) * (                                   &
+                v_comp(k) = v(k,j+1,i) + v(k,j,i)
+                flux_n(k) = ( v_comp(k) - gv ) * (                             &
                           ( 37.0_wp * ibit14 * adv_mom_5                       &
                        +     7.0_wp * ibit13 * adv_mom_3                       &
@@ -5527,5 +5518,5 @@
                                      )
 
-                diss_n = - ABS( v_comp - gv ) * (                              &
+                diss_n(k) = - ABS( v_comp(k) - gv ) * (                        &
                           ( 10.0_wp * ibit14 * adv_mom_5                       &
                        +     3.0_wp * ibit13 * adv_mom_3                       &
@@ -5549,6 +5540,6 @@
                 ibit12_s = REAL( IBITS(advc_flags_m(k,j-1,i),12,1), KIND = wp )
 
-                v_comp_s = v(k,j,i) + v(k,j-1,i) - gv
-                flux_s   = v_comp_s * (                                        &
+                v_comp_s         = v(k,j,i) + v(k,j-1,i) - gv
+                flux_s_v(k,tn)   = v_comp_s * (                                &
                                    ( 37.0_wp * ibit14_s * adv_mom_5            &
                                 +     7.0_wp * ibit13_s * adv_mom_3            &
@@ -5563,7 +5554,7 @@
                                    ) *                                         &
                                      ( v(k,j+2,i) + v(k,j-3,i) )               &
-                                                 )
-
-                diss_s   = - ABS( v_comp_s ) * (                               &
+                                               )
+
+               diss_s_v(k,tn)   = - ABS( v_comp_s ) * (                        &
                                    ( 10.0_wp * ibit14_s * adv_mom_5            &
                                 +     3.0_wp * ibit13_s * adv_mom_3            &
@@ -5578,10 +5569,73 @@
                                    ) *                                         &
                                      ( v(k,j+2,i) - v(k,j-3,i) )               &
-                                                          )
-#else
-               flux_s = swap_flux_y_local_v(k)
-               diss_s = swap_diss_y_local_v(k)
+                                                      )
 #endif
-
+             ENDDO
+
+             DO  k = nzb_max_l+1, nzt
+
+                u_comp(k) = u(k,j-1,i+1) + u(k,j,i+1) - gu
+                flux_r(k) = u_comp(k) * (                                      &
+                      37.0_wp * ( v(k,j,i+1) + v(k,j,i)   )                    &
+                    -  8.0_wp * ( v(k,j,i+2) + v(k,j,i-1) )                    &
+                    +           ( v(k,j,i+3) + v(k,j,i-2) ) ) * adv_mom_5
+
+                diss_r(k) = - ABS( u_comp(k) ) * (                             &
+                      10.0_wp * ( v(k,j,i+1) - v(k,j,i) )                      &
+                    -  5.0_wp * ( v(k,j,i+2) - v(k,j,i-1) )                    &
+                    +           ( v(k,j,i+3) - v(k,j,i-2) ) ) * adv_mom_5
+
+#ifdef _OPENACC
+!
+!--             Recompute the left fluxes.
+                u_comp_l           = u(k,j-1,i) + u(k,j,i) - gu
+                flux_l_v(k,j,tn)   = u_comp_l * (                              &
+                             37.0_wp * ( v(k,j,i) + v(k,j,i-1)   )             &
+                           -  8.0_wp * ( v(k,j,i+1) + v(k,j,i-2) )             &
+                           +           ( v(k,j,i+2) + v(k,j,i-3) ) ) * adv_mom_5
+                diss_l_v(k,j,tn)   = - ABS( u_comp_l ) * (                     &
+                             10.0_wp * ( v(k,j,i) - v(k,j,i-1)   )             &
+                           -  5.0_wp * ( v(k,j,i+1) - v(k,j,i-2) )             &
+                           +           ( v(k,j,i+2) - v(k,j,i-3) ) ) * adv_mom_5
+#endif
+
+                v_comp(k) = v(k,j+1,i) + v(k,j,i)
+                flux_n(k) = ( v_comp(k) - gv ) * (                             &
+                      37.0_wp * ( v(k,j+1,i) + v(k,j,i)   )                    &
+                    -  8.0_wp * ( v(k,j+2,i) + v(k,j-1,i) )                    &
+                      +         ( v(k,j+3,i) + v(k,j-2,i) ) ) * adv_mom_5
+
+                diss_n(k) = - ABS( v_comp(k) - gv ) * (                        &
+                      10.0_wp * ( v(k,j+1,i) - v(k,j,i)   )                    &
+                    -  5.0_wp * ( v(k,j+2,i) - v(k,j-1,i) )                    &
+                    +           ( v(k,j+3,i) - v(k,j-2,i) ) ) * adv_mom_5
+
+#ifdef _OPENACC
+!
+!--             Recompute the south fluxes.
+                v_comp_s = v(k,j,i) + v(k,j-1,i) - gv
+                flux_s_v(k,tn)   = v_comp_s * (                                &
+                           37.0_wp * ( v(k,j,i) + v(k,j-1,i)   )               &
+                         -  8.0_wp * ( v(k,j+1,i) + v(k,j-2,i) )               &
+                         +           ( v(k,j+2,i) + v(k,j-3,i) ) ) * adv_mom_5
+                diss_s_v(k,tn)   = - ABS( v_comp_s ) * (                       &
+                           10.0_wp * ( v(k,j,i) - v(k,j-1,i)   )               &
+                         -  5.0_wp * ( v(k,j+1,i) - v(k,j-2,i) )               &
+                         +           ( v(k,j+2,i) - v(k,j-3,i) ) ) * adv_mom_5
+#endif
+             ENDDO
+!
+!--          Now, compute vertical fluxes. Split loop into a part treating the
+!--          lowest 2 grid points with indirect indexing, a main loop without
+!--          indirect indexing, and a loop for the uppermost 2 grip points with
+!--          indirect indexing. This allows better vectorization for the main loop.
+!--          First, compute the flux at model surface, which need has to be
+!--          calculated explicetely for the tendency at
+!--          the first w-level. For topography wall this is done implicitely by
+!--          advc_flags_m.
+             flux_t(nzb) = 0.0_wp
+             diss_t(nzb) = 0.0_wp
+             w_comp(nzb) = 0.0_wp
+             DO  k = nzb+1, nzb+2
 !
 !--             k index has to be modified near bottom and top, else array
@@ -5595,6 +5649,6 @@
                 k_mm  = k - 2 * ibit17
 
-                w_comp = w(k,j-1,i) + w(k,j,i)
-                flux_t = w_comp * rho_air_zw(k) * (                            &
+                w_comp(k) = w(k,j-1,i) + w(k,j,i)
+                flux_t(k) = w_comp(k) * rho_air_zw(k) * (                      &
                           ( 37.0_wp * ibit17 * adv_mom_5                       &
                        +     7.0_wp * ibit16 * adv_mom_3                       &
@@ -5609,7 +5663,7 @@
                           ) *                                                  &
                              ( v(k_ppp,j,i) + v(k_mm,j,i) )                    &
-                                      )
-
-                diss_t = - ABS( w_comp ) * rho_air_zw(k) * (                   &
+                                                        )
+
+                diss_t(k) = - ABS( w_comp(k) ) * rho_air_zw(k) * (             &
                           ( 10.0_wp * ibit17 * adv_mom_5                       &
                        +     3.0_wp * ibit16 * adv_mom_3                       &
@@ -5624,141 +5678,45 @@
                           ) *                                                  &
                              ( v(k_ppp,j,i) - v(k_mm,j,i) )                    &
-                                               )
-!
-!--             Calculate the divergence of the velocity field. A respective
-!--             correction is needed to overcome numerical instabilities caused
-!--             by a not sufficient reduction of divergences near topography.
-                div = ( ( ( u_comp     + gu )                                  &
-                                       * ( ibit9 + ibit10 + ibit11 )           &
-                - ( u(k,j-1,i)   + u(k,j,i) )                                  &
-                                       * (                                     &
-                        REAL( IBITS(advc_flags_m(k,j,i-1),9,1), KIND = wp )    &
-                      + REAL( IBITS(advc_flags_m(k,j,i-1),10,1), KIND = wp )   &
-                      + REAL( IBITS(advc_flags_m(k,j,i-1),11,1), KIND = wp )   &
-                                         )                                     &
-                  ) * ddx                                                      &
-               +  ( v_comp                                                     &
-                                       * ( ibit12 + ibit13 + ibit14 )          &
-                - ( v(k,j,i)     + v(k,j-1,i) )                                &
-                                       * (                                     &
-                        REAL( IBITS(advc_flags_m(k,j-1,i),12,1), KIND = wp )   &
-                      + REAL( IBITS(advc_flags_m(k,j-1,i),13,1), KIND = wp )   & 
-                      + REAL( IBITS(advc_flags_m(k,j-1,i),14,1), KIND = wp )   &
-                                         )                                     &
-                  ) * ddy                                                      & 
-               +  ( w_comp * rho_air_zw(k)                                     &
-                                       * ( ibit15 + ibit16 + ibit17 )          &
-                - ( w(k-1,j-1,i) + w(k-1,j,i) ) * rho_air_zw(k-1)              &
-                                       * (                                     &
-                        REAL( IBITS(advc_flags_m(k-1,j,i),15,1), KIND = wp )   &
-                      + REAL( IBITS(advc_flags_m(k-1,j,i),16,1), KIND = wp )   &
-                      + REAL( IBITS(advc_flags_m(k-1,j,i),17,1), KIND = wp )   &
-                                         )                                     &
-                   ) * drho_air(k) * ddzw(k)                                   &
-                ) * 0.5_wp
-
-
-                tend(k,j,i) = tend(k,j,i) - (                                  &
-                       ( ( flux_r + diss_r )                                   &
-                     -   ( flux_l + diss_l ) ) * ddx                           &
-                     + ( ( flux_n + diss_n )                                   &
-                     -   ( flux_s + diss_s ) ) * ddy                           &
-                     + ( ( flux_t + diss_t )                                   &
-                     -   ( flux_d + diss_d ) ) * drho_air(k) * ddzw(k)         &
-                                            )  + v(k,j,i) * div
-
-#ifndef _OPENACC
-                swap_flux_x_local_v(k,j) = flux_r
-                swap_diss_x_local_v(k,j) = diss_r
-                swap_flux_y_local_v(k)   = flux_n
-                swap_diss_y_local_v(k)   = diss_n
-#endif
-                flux_d                   = flux_t
-                diss_d                   = diss_t
-
-!
-!--             Statistical Evaluation of v'v'. The factor has to be applied
-!--             for right evaluation when gallilei_trans = .T. .
-                !$ACC ATOMIC
-                sums_vs2_ws_l(k,tn) = sums_vs2_ws_l(k,tn)                      &
-                + ( flux_n                                                     &
-                    * ( v_comp - 2.0_wp * hom(k,1,2,0)                   )     &
-                    / ( v_comp - gv + SIGN( 1.0E-20_wp, v_comp - gv )    )     &
-               +   diss_n                                                      &
-                    *   ABS( v_comp - 2.0_wp * hom(k,1,2,0)              )     &
-                    / ( ABS( v_comp - gv ) + 1.0E-20_wp                  )     &
-                  ) *   weight_substep(intermediate_timestep_count)
-!
-!--             Statistical Evaluation of w'u'.
-                !$ACC ATOMIC
-                sums_wsvs_ws_l(k,tn) = sums_wsvs_ws_l(k,tn)                    &
-                + ( flux_t                                                     &
-                    * ( w_comp - 2.0_wp * hom(k,1,3,0)                   )     &
-                    / ( w_comp + SIGN( 1.0E-20_wp, w_comp )              )     &
-               +   diss_t                                                      &
-                    *   ABS( w_comp - 2.0_wp * hom(k,1,3,0)              )     &
-                    / ( ABS( w_comp ) + 1.0E-20_wp                       )     &
-                  ) *   weight_substep(intermediate_timestep_count)
-
+                                                                 )
              ENDDO
 
-             DO  k = nzb_max_l+1, nzt
-
-                u_comp = u(k,j-1,i+1) + u(k,j,i+1) - gu
-                flux_r = u_comp * (                                            &
-                      37.0_wp * ( v(k,j,i+1) + v(k,j,i)   )                    &
-                    -  8.0_wp * ( v(k,j,i+2) + v(k,j,i-1) )                    &
-                    +           ( v(k,j,i+3) + v(k,j,i-2) ) ) * adv_mom_5
-
-                diss_r = - ABS( u_comp ) * (                                   &
-                      10.0_wp * ( v(k,j,i+1) - v(k,j,i) )                      &
-                    -  5.0_wp * ( v(k,j,i+2) - v(k,j,i-1) )                    &
-                    +           ( v(k,j,i+3) - v(k,j,i-2) ) ) * adv_mom_5
-
-#ifdef _OPENACC
-!
-!--             Recompute the left fluxes.
-                u_comp_l = u(k,j-1,i) + u(k,j,i) - gu
-                flux_l   = u_comp_l * (                                        &
-                             37.0_wp * ( v(k,j,i) + v(k,j,i-1)   )             &
-                           -  8.0_wp * ( v(k,j,i+1) + v(k,j,i-2) )             &
-                           +           ( v(k,j,i+2) + v(k,j,i-3) ) ) * adv_mom_5
-                diss_l   = - ABS( u_comp_l ) * (                               &
-                             10.0_wp * ( v(k,j,i) - v(k,j,i-1)   )             &
-                           -  5.0_wp * ( v(k,j,i+1) - v(k,j,i-2) )             &
-                           +           ( v(k,j,i+2) - v(k,j,i-3) ) ) * adv_mom_5
-#else
-                flux_l = swap_flux_x_local_v(k,j)
-                diss_l = swap_diss_x_local_v(k,j)
-#endif
-
-                v_comp = v(k,j+1,i) + v(k,j,i)
-                flux_n = ( v_comp - gv ) * (                                   &
-                      37.0_wp * ( v(k,j+1,i) + v(k,j,i)   )                    &
-                    -  8.0_wp * ( v(k,j+2,i) + v(k,j-1,i) )                    &
-                      +         ( v(k,j+3,i) + v(k,j-2,i) ) ) * adv_mom_5
-
-                diss_n = - ABS( v_comp - gv ) * (                              &
-                      10.0_wp * ( v(k,j+1,i) - v(k,j,i)   )                    &
-                    -  5.0_wp * ( v(k,j+2,i) - v(k,j-1,i) )                    &
-                    +           ( v(k,j+3,i) - v(k,j-2,i) ) ) * adv_mom_5
-
-#ifdef _OPENACC
-!
-!--             Recompute the south fluxes.
-                v_comp_s = v(k,j,i) + v(k,j-1,i) - gv
-                flux_s   = v_comp_s * (                                        &
-                           37.0_wp * ( v(k,j,i) + v(k,j-1,i)   )               &
-                         -  8.0_wp * ( v(k,j+1,i) + v(k,j-2,i) )               &
-                         +           ( v(k,j+2,i) + v(k,j-3,i) ) ) * adv_mom_5
-                diss_s   = - ABS( v_comp_s ) * (                               &
-                           10.0_wp * ( v(k,j,i) - v(k,j-1,i)   )               &
-                         -  5.0_wp * ( v(k,j+1,i) - v(k,j-2,i) )               &
-                         +           ( v(k,j+2,i) - v(k,j-3,i) ) ) * adv_mom_5
-#else
-                flux_s = swap_flux_y_local_v(k)
-                diss_s = swap_diss_y_local_v(k)
-#endif
-
+             DO  k = nzb+3, nzt-2
+                ibit17 = REAL( IBITS(advc_flags_m(k,j,i),17,1), KIND = wp )
+                ibit16 = REAL( IBITS(advc_flags_m(k,j,i),16,1), KIND = wp )
+                ibit15 = REAL( IBITS(advc_flags_m(k,j,i),15,1), KIND = wp )
+
+                w_comp(k) = w(k,j-1,i) + w(k,j,i)
+                flux_t(k) = w_comp(k) * rho_air_zw(k) * (                      &
+                          ( 37.0_wp * ibit17 * adv_mom_5                       &
+                       +     7.0_wp * ibit16 * adv_mom_3                       &
+                       +              ibit15 * adv_mom_1                       &
+                          ) *                                                  &
+                             ( v(k+1,j,i)  + v(k,j,i)    )                     &
+                   -      (  8.0_wp * ibit17 * adv_mom_5                       &
+                       +              ibit16 * adv_mom_3                       &
+                          ) *                                                  &
+                             ( v(k+2,j,i) + v(k-1,j,i)   )                     &
+                   +      (           ibit17 * adv_mom_5                       &
+                          ) *                                                  &
+                             ( v(k+3,j,i) + v(k-2,j,i)   )                     &
+                                                        )
+
+                diss_t(k) = - ABS( w_comp(k) ) * rho_air_zw(k) * (             &
+                          ( 10.0_wp * ibit17 * adv_mom_5                       &
+                       +     3.0_wp * ibit16 * adv_mom_3                       &
+                       +              ibit15 * adv_mom_1                       &
+                          ) *                                                  &
+                             ( v(k+1,j,i) - v(k,j,i)     )                     &
+                   -      (  5.0_wp * ibit17 * adv_mom_5                       &
+                       +              ibit16 * adv_mom_3                       &
+                          ) *                                                  &
+                             ( v(k+2,j,i) - v(k-1,j,i)   )                     &
+                   +      (           ibit17 * adv_mom_5                       &
+                          ) *                                                  &
+                             ( v(k+3,j,i) - v(k-2,j,i)   )                     &
+                                                                 )
+             ENDDO
+
+             DO  k = nzt-1, nzt-symmetry_flag
 !
 !--             k index has to be modified near bottom and top, else array
@@ -5772,6 +5730,6 @@
                 k_mm  = k - 2 * ibit17
 
-                w_comp = w(k,j-1,i) + w(k,j,i)
-                flux_t = w_comp * rho_air_zw(k) * (                            &
+                w_comp(k) = w(k,j-1,i) + w(k,j,i)
+                flux_t(k) = w_comp(k) * rho_air_zw(k) * (                      &
                           ( 37.0_wp * ibit17 * adv_mom_5                       &
                        +     7.0_wp * ibit16 * adv_mom_3                       &
